struct PS_INPUT
{
  float2 Tex0: TEXCOORD0;
};

sampler base_map = sampler_state
{
  MipFilter = LINEAR;
  MinFilter = LINEAR;
  MagFilter = LINEAR;
};

float4 PS(PS_INPUT In) : COLOR0
{
  float4 color = tex2D(base_map, In.Tex0) * 0.5;
  color += tex2D(base_map, In.Tex0 + float2(0.0078125 * 1,0)) * 0.42;
  color += tex2D(base_map, In.Tex0 - float2(0.0078125 * 1,0)) * 0.42;
  color += tex2D(base_map, In.Tex0 + float2(0.0078125 * 2,0)) * 0.35;
  color += tex2D(base_map, In.Tex0 - float2(0.0078125 * 2,0)) * 0.35;
  color += tex2D(base_map, In.Tex0 + float2(0.0078125 * 3,0)) * 0.23;
  color += tex2D(base_map, In.Tex0 - float2(0.0078125 * 3,0)) * 0.23;
  color += tex2D(base_map, In.Tex0 + float2(0.0078125 * 4,0)) * 0.19;
  color += tex2D(base_map, In.Tex0 - float2(0.0078125 * 4,0)) * 0.19;
  color += tex2D(base_map, In.Tex0 + float2(0.0078125 * 5,0)) * 0.14;
  color += tex2D(base_map, In.Tex0 - float2(0.0078125 * 5,0)) * 0.14;
  color += tex2D(base_map, In.Tex0 + float2(0.0078125 * 6,0)) * 0.10;
  color += tex2D(base_map, In.Tex0 - float2(0.0078125 * 6,0)) * 0.10;
  color*=0.5;
  
  return color;
}

technique Blur
{
  pass Blur
  {
    PixelShader = compile ps_2_0 PS();
  }
}
